import '@nativescript/macos-node-api';
import type { NativeWindow } from './views/window/native-window.js';
import type { Window } from './views/window/window.js';
declare class AppDelegate extends NSObject implements NSApplicationDelegate {
    window?: NativeWindow;
    running: boolean;
    isActive: boolean;
    static windowTitle: string;
    static ObjCProtocols: (typeof NSApplicationDelegate)[];
    static ObjCExposedMethods: {
        showMainWindow: {
            returns: number;
            params: number[];
        };
        themeChanged: {
            returns: number;
            params: number[];
        };
    };
    applicationDidFinishLaunching(_notification: NSNotification): void;
    applicationShouldHandleReopenHasVisibleWindows(sender: NSApplication, hasVisibleWindows: boolean): boolean;
    applicationWillTerminate(_notification: NSNotification): void;
    showMainWindow(_id: this): void;
    themeChanged(_id: this): void;
}
export declare class Application {
    static delegate: AppDelegate;
    static application: NSApplication;
    static rootView: HTMLViewElement;
    static window: Window;
    static appMenu: NSMenu;
    static ensure60FPS: boolean;
    static launch(): void;
    static createMenu(): void;
    static showMainWindow(): void;
}
declare global {
    var NativeScriptApplication: typeof Application;
}
export {};
