var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
import '@nativescript/macos-node-api';
objc.import('AppKit');
let AppDelegate = class AppDelegate extends NSObject {
    window;
    running = true;
    isActive = true;
    static windowTitle;
    static ObjCProtocols = [NSApplicationDelegate];
    static ObjCExposedMethods = {
        showMainWindow: { returns: interop.types.void, params: [interop.types.id] },
        themeChanged: { returns: interop.types.void, params: [interop.types.id] },
    };
    applicationDidFinishLaunching(_notification) {
        // Allow users to customize the app's Touch Bar items
        NSApplication.sharedApplication.isAutomaticCustomizeTouchBarMenuItemEnabled = true;
        NSDistributedNotificationCenter.defaultCenter.addObserverSelectorNameObject(this, 'themeChanged', 'AppleInterfaceThemeChangedNotification', null);
        if (!NSBundle.mainBundle?.objectForInfoDictionaryKey('NativeScriptApplication')) {
            NSApp.activateIgnoringOtherApps(false);
            NSApp.stop(this);
            RunLoop();
        }
    }
    applicationShouldHandleReopenHasVisibleWindows(sender, hasVisibleWindows) {
        if (!hasVisibleWindows) {
            sender.windows.firstObject.makeKeyAndOrderFront(sender);
        }
        return true;
    }
    applicationWillTerminate(_notification) {
        this.running = false;
    }
    showMainWindow(_id) {
        NativeScriptApplication.showMainWindow();
    }
    themeChanged(_id) {
        console.log('themeChanged', NSApp.effectiveAppearance.name === 'NSAppearanceNameDarkAqua' ? 'dark' : 'light');
    }
};
AppDelegate = __decorate([
    NativeClass
], AppDelegate);
function RunLoop() {
    let delay = 2;
    let lastEventTime = 0;
    const loop = () => {
        const event = NSApp.nextEventMatchingMaskUntilDateInModeDequeue(NSEventMask.Any, null, 'kCFRunLoopDefaultMode', true);
        const timeSinceLastEvent = Date.now() - lastEventTime;
        if (event != null) {
            NSApp.sendEvent(event);
            delay = timeSinceLastEvent < 32 ? 2 : 8;
            lastEventTime = Date.now();
        }
        else {
            delay = timeSinceLastEvent > 6000 ? 128 : timeSinceLastEvent > 4000 ? 64 : timeSinceLastEvent > 2000 ? 16 : 8;
        }
        if (NativeScriptApplication.delegate.running) {
            setTimeout(loop, NativeScriptApplication.ensure60FPS ? 8 : delay);
        }
    };
    setTimeout(loop, 0);
}
export class Application {
    static delegate;
    static application;
    static rootView;
    static window;
    static appMenu;
    static ensure60FPS;
    static launch() {
        if (!(document.body instanceof HTMLElement)) {
            throw new Error('document.body instance of NSView');
        }
        Application.rootView = document.body;
        Application.rootView?.connectedCallback();
        if (NativeScriptApplication.window) {
            NativeScriptApplication.window.open();
        }
        else {
            throw new Error('Window is not initialized');
        }
        Application.application = NSApplication.sharedApplication;
        Application.delegate = AppDelegate.new();
        Application.delegate.window = NativeScriptApplication.window.nativeView;
        Application.createMenu();
        NSApp.delegate = Application.delegate;
        NSApp.setActivationPolicy(NSApplicationActivationPolicy.Regular);
        NSApp.run();
    }
    static createMenu() {
        if (!Application.appMenu) {
            const menu = NSMenu.new();
            NSApp.mainMenu = menu;
            Application.appMenu = menu;
        }
    }
    static showMainWindow() {
        // override
    }
}
globalThis.NativeScriptApplication = Application;
//# sourceMappingURL=application.js.map