import { type YogaNodeLayout } from '../../layout/index.js';
import type { NativePropertyConfig } from '../decorators/native.js';
import { TextBase } from '../text/text-base.js';
import { NativeButton } from './native-button.js';
export type ButtonEvents = 'click';
export declare class Button extends TextBase {
    supportedNodeTypes: 3[];
    nativeView?: NativeButton;
    get isLeaf(): boolean;
    initNativeView(): NativeButton;
    prepareNativeView(nativeView: NativeButton): void;
    updateTextContent(): void;
    title: string;
    setColor(key: string, value: string, config: NativePropertyConfig<string>): void;
    setBackgroundColor(_key: string, value: string, _config: NativePropertyConfig<string>): void;
    bezelStyle: number;
    buttonType: number;
    icon: string;
    onMeasureFunction(width: number, widthMode: any, height: number, heightMode: any): {
        width: number;
        height: number;
    };
    applyLayout(parentLayout?: YogaNodeLayout): void;
}
