import '@nativescript/macos-node-api';
import { Event } from '../../dom/dom-utils.js';
import type { Button } from './button.js';
export declare class ButtonClickEvent extends Event {
    state?: boolean;
    constructor(state: boolean, eventDict?: EventInit);
}
export declare class NativeButton extends NSButton {
    static ObjCExposedMethods: {
        clicked: {
            returns: number;
            params: number[];
        };
    };
    _attributedTitle?: NSMutableAttributedString;
    _color?: NSColor;
    _title?: string;
    _owner?: WeakRef<Button>;
    static initWithOwner(owner: WeakRef<Button>): NativeButton;
    clicked(_id: this): void;
    setTitle(title: string): void;
    setTitleColor(color: NSColor): void;
    updateButtonTitleStyle(): void;
}
