var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var NativeColorOpenButton_1;
import '@nativescript/macos-node-api';
import { openColorDialog } from '../../dialogs/color/color-dialog.js';
import { NativeButton } from '../button/native-button.js';
import { Event } from '../../dom/dom-utils.js';
export class ColorChosenEvent extends Event {
    constructor(color, eventDict) {
        super('colorChosen', eventDict);
        this.color = color;
    }
}
let NativeColorOpenButton = class NativeColorOpenButton extends NativeButton {
    static { NativeColorOpenButton_1 = this; }
    static ObjCExposedMethods = {
        clicked: { returns: interop.types.void, params: [interop.types.id] },
    };
    static initWithOwner(owner) {
        const button = NativeColorOpenButton_1.new();
        button._owner = owner;
        return button;
    }
    clicked(_id) {
        const owner = this._owner?.deref();
        if (owner) {
            openColorDialog(owner.options || {})
                .then((result) => {
                owner.dispatchEvent(new ColorChosenEvent(result));
            })
                .catch((err) => {
                console.error(err);
            });
        }
    }
};
NativeColorOpenButton = NativeColorOpenButton_1 = __decorate([
    NativeClass
], NativeColorOpenButton);
export { NativeColorOpenButton };
//# sourceMappingURL=native-coloropenbutton.js.map