import '@nativescript/macos-node-api';
import { Event } from '../../dom/dom-utils.js';
import type { ComboBox } from './combobox.js';
export declare class ComboBoxChangeEvent extends Event {
    index: number;
    constructor(index: number, eventDict?: EventInit);
}
export declare class NativeComboBoxDelegate extends NSObject implements NSComboBoxDelegate {
    static ObjCProtocols: (typeof NSComboBoxDelegate)[];
    _owner: WeakRef<NativeComboBox>;
    static initWithOwner(owner: WeakRef<NativeComboBox>): NativeComboBoxDelegate;
    comboBoxSelectionDidChange(_notification: NSNotification): void;
}
export declare class NativeComboBox extends NSComboBox {
    _items?: Array<string>;
    _owner?: WeakRef<ComboBox>;
    static initWithOwner(owner: WeakRef<ComboBox>): NativeComboBox;
    itemChange(): void;
    setItems(items: Array<string>): void;
}
