import '@nativescript/macos-node-api';
import { Event } from '../../dom/dom-utils.js';
import type { YogaNodeLayout } from '../../layout/index.js';
import { View } from '../view/view.js';
export declare class DatePickerChangeEvent extends Event {
    date?: Date;
    interval?: number;
    constructor(date: Date, interval: number, eventDict?: EventInit);
}
export declare class DatePicker extends View {
    get isLeaf(): boolean;
    nativeView?: NSDatePicker;
    initNativeView(): NSDatePicker | undefined;
    date: Date;
    minDate: Date;
    maxDate: Date;
    datePickerStyle: 'textFieldAndStepper' | 'clockAndCalendar' | 'textField';
    datePickerElements: number;
    presentsCalendarOverlay: boolean;
    datePickerMode: 'single' | 'range';
    applyLayout(parentLayout?: YogaNodeLayout): void;
}
