var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
import '@nativescript/macos-node-api';
import { Event } from '../../dom/dom-utils.js';
import { NativeTarget } from '../common/native-target.js';
import { native } from '../decorators/native.js';
import { view } from '../decorators/view.js';
import { View } from '../view/view.js';
export class DatePickerChangeEvent extends Event {
    constructor(date, interval, eventDict) {
        super('dateChange', eventDict);
        this.date = date;
        this.interval = interval;
    }
}
let DatePicker = class DatePicker extends View {
    get isLeaf() {
        return true;
    }
    nativeView = undefined;
    initNativeView() {
        this.nativeView = NSDatePicker.alloc().init();
        this.nativeView.dateValue = NSDate.dateWithTimeIntervalSince1970(Date.now() / 1000);
        const target = NativeTarget.initWithAction(() => {
            if (this.nativeView) {
                this.dispatchEvent(new DatePickerChangeEvent(new Date(this.nativeView.dateValue.timeIntervalSince1970 * 1000), this.nativeView.timeInterval * 1000));
            }
        });
        this.nativeView.action = target.selector;
        this.nativeView.target = target;
        return this.nativeView;
    }
    applyLayout(parentLayout) {
        super.applyLayout(parentLayout);
        if (this.nativeView) {
            this.nativeView.translatesAutoresizingMaskIntoConstraints = true;
        }
    }
};
__decorate([
    native({
        setNative(view, _key, value) {
            if (view.nativeView) {
                view.nativeView.dateValue = NSDate.dateWithTimeIntervalSince1970(value.getTime() / 1000);
            }
        },
    }),
    __metadata("design:type", Date)
], DatePicker.prototype, "date", void 0);
__decorate([
    native({
        setNative(view, _key, value) {
            if (view.nativeView) {
                view.nativeView.minDate = NSDate.dateWithTimeIntervalSince1970(value.getTime() / 1000);
            }
        },
    }),
    __metadata("design:type", Date)
], DatePicker.prototype, "minDate", void 0);
__decorate([
    native({
        setNative(view, _key, value) {
            if (view.nativeView) {
                view.nativeView.maxDate = NSDate.dateWithTimeIntervalSince1970(value.getTime() / 1000);
            }
        },
    }),
    __metadata("design:type", Date)
], DatePicker.prototype, "maxDate", void 0);
__decorate([
    native({
        setNative(view, _key, value) {
            if (view.nativeView) {
                view.nativeView.datePickerStyle = value === 'clockAndCalendar' ? NSDatePickerStyle.ClockAndCalendar : value === 'textField' ? NSDatePickerStyle.TextField : NSDatePickerStyle.TextFieldAndStepper;
            }
        },
    }),
    __metadata("design:type", String)
], DatePicker.prototype, "datePickerStyle", void 0);
__decorate([
    native({
        setNative(view, _key, value) {
            if (view.nativeView) {
                view.nativeView.datePickerElements = value;
            }
        },
    }),
    __metadata("design:type", Number)
], DatePicker.prototype, "datePickerElements", void 0);
__decorate([
    native({
        setNative(view, _key, value) {
            if (view.nativeView) {
                view.nativeView.presentsCalendarOverlay = value;
            }
        },
    }),
    __metadata("design:type", Boolean)
], DatePicker.prototype, "presentsCalendarOverlay", void 0);
__decorate([
    native({
        setNative(view, _key, value) {
            if (view.nativeView) {
                view.nativeView.datePickerMode = value;
            }
        },
    }),
    __metadata("design:type", String)
], DatePicker.prototype, "datePickerMode", void 0);
DatePicker = __decorate([
    view({
        name: 'HTMLDatePickerElement',
        tagName: 'date-picker',
    })
], DatePicker);
export { DatePicker };
//# sourceMappingURL=date-picker.js.map