var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var NativeFileSaveButton_1;
import '@nativescript/macos-node-api';
import { saveFileDialog } from '../../dialogs/file/file-dialog.js';
import { NativeButton } from '../button/native-button.js';
import { Event } from '../../dom/dom-utils.js';
export class FileSaveEvent extends Event {
    constructor(path, eventDict) {
        super('fileSave', eventDict);
        this.path = path;
    }
}
let NativeFileSaveButton = class NativeFileSaveButton extends NativeButton {
    static { NativeFileSaveButton_1 = this; }
    static ObjCExposedMethods = {
        clicked: { returns: interop.types.void, params: [interop.types.id] },
    };
    static initWithOwner(owner) {
        const button = NativeFileSaveButton_1.new();
        button._owner = owner;
        return button;
    }
    clicked(_id) {
        const owner = this._owner?.deref();
        if (owner) {
            saveFileDialog(owner.options || {})
                .then((result) => {
                owner.dispatchEvent(new FileSaveEvent(result));
            })
                .catch((err) => {
                console.error(err);
            });
        }
    }
};
NativeFileSaveButton = NativeFileSaveButton_1 = __decorate([
    NativeClass
], NativeFileSaveButton);
export { NativeFileSaveButton };
//# sourceMappingURL=native-filesavebutton.js.map