import '@nativescript/macos-node-api';
import { Event } from '../../dom/dom-utils.js';
import { ViewBase } from '../view/view-base.js';
export declare class MenuItemClickEvent extends Event {
    state?: boolean;
    constructor(state: boolean, eventDict?: EventInit);
}
declare class NativeMenuItem extends NSMenuItem {
    static ObjCExposedMethods: {
        clicked: {
            returns: number;
            params: never[];
        };
    };
    isEnabled: boolean;
    isIncludedInLayout: boolean;
    private _owner?;
    static initWithOwner(owner: WeakRef<MenuItem>): NativeMenuItem;
    clicked(): void;
}
export declare class MenuItem extends ViewBase {
    isRoot: boolean;
    nativeView: NativeMenuItem;
    initNativeView(): NativeMenuItem;
    addNativeChild(child: any): void;
    removeNativeChild(child: any): void;
    insertBefore<T extends Node>(node: T, child: Node | null): T;
    removeChild<T extends Node>(child: T): T;
    title: string;
    icon: string;
    shortcutKey: string;
    enabled: boolean;
    state: 'on' | 'off' | 'mixed';
    onIcon: string;
    offIcon: string;
    mixedIcon: string;
    hidden: boolean;
}
export {};
