var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var NativeMenuItem_1;
import '@nativescript/macos-node-api';
import { Event } from '../../dom/dom-utils.js';
import { native } from '../decorators/native.js';
import { view } from '../decorators/view.js';
import { ViewBase } from '../view/view-base.js';
export class MenuItemClickEvent extends Event {
    constructor(state, eventDict) {
        super('click', eventDict);
        this.state = state;
    }
}
let NativeMenuItem = class NativeMenuItem extends NSMenuItem {
    static { NativeMenuItem_1 = this; }
    static ObjCExposedMethods = {
        clicked: { returns: interop.types.void, params: [] },
    };
    isEnabled = false;
    isIncludedInLayout = false;
    _owner;
    static initWithOwner(owner) {
        const menu = NativeMenuItem_1.alloc().init();
        menu.target = menu;
        menu.action = 'clicked';
        menu._owner = owner;
        return menu;
    }
    clicked() {
        const owner = this._owner?.deref();
        if (owner) {
            owner.dispatchEvent(new MenuItemClickEvent(true));
        }
    }
};
NativeMenuItem = NativeMenuItem_1 = __decorate([
    NativeClass
], NativeMenuItem);
let MenuItem = class MenuItem extends ViewBase {
    isRoot = true;
    initNativeView() {
        const menu = NativeMenuItem.initWithOwner(new WeakRef(this));
        this.nativeView = menu;
        return this.nativeView;
    }
    addNativeChild(child) {
        if (child.nodeName === 'MENU') {
            this.nativeView.submenu = child.nativeView;
        }
        else {
            this.nativeView.view = child.nativeView;
        }
    }
    removeNativeChild(child) {
        if (child.nodeName === 'MENU') {
            //@ts-expect-error can be null;
            this.nativeView.submenu = null;
        }
        else {
            //@ts-expect-error can be null;
            this.nativeView.view = null;
        }
    }
    insertBefore(node, child) {
        if (node.nodeName === 'MENU') {
            node.shouldAttachToParentNativeView = true;
        }
        return super.insertBefore(node, child);
    }
    removeChild(child) {
        if (child.nodeName === 'MENU') {
            child.shouldAttachToParentNativeView = false;
        }
        return super.removeChild(child);
    }
};
__decorate([
    native({
        setNative: (view, _key, value) => {
            if (view.nativeView) {
                view.nativeView.title = value;
            }
        },
    }),
    __metadata("design:type", String)
], MenuItem.prototype, "title", void 0);
__decorate([
    native({
        setNative(view, _key, value) {
            if (view.nativeView) {
                //@ts-expect-error can be null;
                view.nativeView.image = !value ? null : NSImage.imageWithSystemSymbolNameAccessibilityDescription(value, null);
            }
        },
    }),
    __metadata("design:type", String)
], MenuItem.prototype, "icon", void 0);
__decorate([
    native({
        setNative(view, _key, value) {
            if (view.nativeView) {
                view.nativeView.keyEquivalent = value;
            }
        },
    }),
    __metadata("design:type", String)
], MenuItem.prototype, "shortcutKey", void 0);
__decorate([
    native({
        setNative(view, _key, value) {
            if (view.nativeView) {
                view.nativeView.isEnabled = value;
            }
        },
    }),
    __metadata("design:type", Boolean)
], MenuItem.prototype, "enabled", void 0);
__decorate([
    native({
        setNative(view, _key, value) {
            if (view.nativeView) {
                view.nativeView.state = value === 'on' ? NSControlStateValueOn : value === 'mixed' ? NSControlStateValueMixed : NSControlStateValueOff;
            }
        },
    }),
    __metadata("design:type", String)
], MenuItem.prototype, "state", void 0);
__decorate([
    native({
        setNative(view, _key, value) {
            if (view.nativeView) {
                const image = NSImage.imageWithSystemSymbolNameAccessibilityDescription(value, null);
                view.nativeView.onStateImage = image;
            }
        },
    }),
    __metadata("design:type", String)
], MenuItem.prototype, "onIcon", void 0);
__decorate([
    native({
        setNative(view, _key, value) {
            if (view.nativeView) {
                const image = NSImage.imageWithSystemSymbolNameAccessibilityDescription(value, null);
                view.nativeView.offStateImage = image;
            }
        },
    }),
    __metadata("design:type", String)
], MenuItem.prototype, "offIcon", void 0);
__decorate([
    native({
        setNative(view, _key, value) {
            if (view.nativeView) {
                const image = NSImage.imageWithSystemSymbolNameAccessibilityDescription(value, null);
                view.nativeView.mixedStateImage = image;
            }
        },
    }),
    __metadata("design:type", String)
], MenuItem.prototype, "mixedIcon", void 0);
__decorate([
    native({
        setNative: (view, _key, value) => {
            if (view.nativeView) {
                view.nativeView.isHidden = value;
            }
        },
    }),
    __metadata("design:type", Boolean)
], MenuItem.prototype, "hidden", void 0);
MenuItem = __decorate([
    view({
        name: 'HTMLMenuElement',
        tagName: 'menu-item',
    })
], MenuItem);
export { MenuItem };
//# sourceMappingURL=menu-item.js.map