var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var MenuAction_1;
import { native } from '../decorators/native.js';
import { view } from '../decorators/view.js';
import { ViewBase } from '../view/view-base.js';
let MenuAction = class MenuAction extends NSObject {
    static { MenuAction_1 = this; }
    static ObjCExposedMethods = {
        clicked: { returns: interop.types.void, params: [interop.types.id] },
    };
    owner;
    static initWithOwner(owner) {
        const menu = MenuAction_1.alloc().init();
        menu.owner = owner;
        return menu;
    }
    clicked() {
        const owner = this.owner?.deref();
        if (owner?._menu) {
            owner.nativeView?.popUpStatusItemMenu(owner._menu.nativeView);
        }
        else if (owner?._popover) {
            // @ts-ignore
            if (owner._popover.nativeView?.isShown) {
                owner._popover.hide();
            }
            else {
                owner._popover.show({
                    nativeView: owner.nativeView.button,
                });
            }
        }
    }
};
MenuAction = MenuAction_1 = __decorate([
    NativeClass
], MenuAction);
let StatusBar = class StatusBar extends ViewBase {
    shouldAttachToParentNativeView = false;
    isRoot = true;
    _popover;
    _menu;
    menuAction;
    initNativeView() {
        this.nativeView = NSStatusBar.systemStatusBar.statusItemWithLength(NSVariableStatusItemLength);
        this.menuAction = MenuAction.initWithOwner(new WeakRef(this));
        this.nativeView.button.action = 'clicked';
        this.nativeView.button.target = this.menuAction;
        return this.nativeView;
    }
    insertBefore(node, child) {
        if (node.nodeName === 'MENU' || node.nodeName === 'POPOVER') {
            node.shouldAttachToParentNativeView = true;
        }
        return super.insertBefore(node, child);
    }
    addNativeChild(child) {
        if (child.nodeName === 'MENU') {
            this._menu = child;
        }
        else if (child.nodeName === 'POPOVER') {
            this._popover = child;
        }
        else {
            this.nativeView.button.addSubview(child.nativeView);
        }
    }
    removeNativeChild(child) {
        if (child.nodeName === 'MENU') {
            //@ts-expect-error can be null
            this.nativeView.menu = null;
        }
        else {
            child.nativeView.removeFromSuperview();
        }
    }
    applyLayout(parentLayout) {
        super.applyLayout(parentLayout);
        if (this.nativeView) {
            //@ts-ignore
            this.nativeView.button.frame = this.nativeView?.frame;
        }
    }
    disposeNativeView() {
        NSStatusBar.systemStatusBar.removeStatusItem(this.nativeView);
        super.disposeNativeView();
    }
};
__decorate([
    native({
        setNative: (view, key, value) => {
            if (view.nativeView) {
                view.nativeView.title = value;
            }
        },
    }),
    __metadata("design:type", String)
], StatusBar.prototype, "title", void 0);
StatusBar = __decorate([
    view({
        name: 'HTMLStatusBarElement',
        tagName: 'status-bar',
    })
], StatusBar);
export { StatusBar };
//# sourceMappingURL=status-bar.js.map