var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
import { Event } from '../../dom/dom-utils.js';
import { NativeTarget } from '../common/native-target.js';
import { native } from '../decorators/native.js';
import { view } from '../decorators/view.js';
import { ViewBase } from '../view/view-base.js';
export class SwitchClickEvent extends Event {
    constructor(state, eventDict) {
        super('click', eventDict);
        this.value = state;
    }
}
let Switch = class Switch extends ViewBase {
    get isLeaf() {
        return true;
    }
    initNativeView() {
        this.nativeView = NSSwitch.alloc().init();
        const target = NativeTarget.initWithAction(() => {
            this.dispatchEvent(new SwitchClickEvent(this.nativeView?.state === NSControlStateValueOn));
        });
        this.nativeView.target = target;
        this.nativeView.action = target.selector;
        this.nativeView.isEnabled = true;
        return this.nativeView;
    }
    applyLayout(parentLayout) {
        super.applyLayout(parentLayout);
        if (this.nativeView) {
            this.nativeView.translatesAutoresizingMaskIntoConstraints = true;
        }
    }
};
__decorate([
    native({
        setNative(view, key, value) {
            if (view.nativeView) {
                view.nativeView.isContinuous = value;
            }
        },
    }),
    __metadata("design:type", Boolean)
], Switch.prototype, "continuous", void 0);
__decorate([
    native({
        setNative(view, key, value) {
            if (view.nativeView) {
                view.nativeView.state = value ? NSControlStateValueOn : NSControlStateValueOff;
            }
        },
    }),
    __metadata("design:type", Boolean)
], Switch.prototype, "value", void 0);
__decorate([
    native({
        setNative(view, key, value) {
            if (view.nativeView) {
                view.nativeView.isEnabled = value;
            }
        },
    }),
    __metadata("design:type", Boolean)
], Switch.prototype, "enabled", void 0);
Switch = __decorate([
    view({
        name: 'HTMLSwitchElement',
        tagName: 'switch',
    })
], Switch);
export { Switch };
//# sourceMappingURL=switch.js.map