var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var NativeTextFieldDelegate_1;
import '@nativescript/macos-node-api';
import { Event } from '../../dom/dom-utils.js';
import { Layout } from '../../layout/index.js';
import { native } from '../decorators/native.js';
import { view } from '../decorators/view.js';
import { Text } from '../text/text.js';
export class TextChangeEvent extends Event {
    value;
    constructor(value, eventDict) {
        super('textChange', eventDict);
        this.value = value;
        this.value = value;
    }
}
export class TextSubmitEvent extends Event {
    value;
    constructor(value, eventDict) {
        super('submit', eventDict);
        this.value = value;
        this.value = value;
    }
}
let NativeTextFieldDelegate = class NativeTextFieldDelegate extends NSObject {
    static { NativeTextFieldDelegate_1 = this; }
    static ObjCProtocols = [NSTextFieldDelegate];
    static initWithOwner(owner) {
        const delegate = NativeTextFieldDelegate_1.new();
        delegate._owner = owner;
        return delegate;
    }
    controlTextDidChange(obj) {
        const owner = this._owner?.deref();
        if (owner) {
            owner._defaultValueSet = true;
            owner.dispatchEvent(new TextChangeEvent(owner.nativeView.stringValue));
            owner.yogaNode.markDirty();
            Layout.computeAndLayout(owner);
        }
    }
    controlTextSubmit() {
        const owner = this._owner?.deref();
        if (owner) {
            if (!owner.nativeView?.stringValue)
                return;
            owner.dispatchEvent(new TextSubmitEvent(owner.nativeView.stringValue));
        }
    }
    static ObjCExposedMethods = {
        controlTextSubmit: { returns: interop.types.void, params: [] },
    };
};
NativeTextFieldDelegate = NativeTextFieldDelegate_1 = __decorate([
    NativeClass
], NativeTextFieldDelegate);
export { NativeTextFieldDelegate };
let TextField = class TextField extends Text {
    _delegate;
    initNativeView() {
        const nativeView = super.initNativeView();
        nativeView.delegate = NativeTextFieldDelegate.initWithOwner(new WeakRef(this));
        this._delegate = nativeView.delegate;
        nativeView.stringValue = '';
        nativeView.focusRingType = NSFocusRingType.None;
        nativeView.usesSingleLineMode = true;
        nativeView.target = this._delegate;
        nativeView.action = 'controlTextSubmit';
        return nativeView;
    }
    prepareNativeView(nativeView) {
        super.prepareNativeView(nativeView);
        nativeView.isEditable = true;
    }
    updateTextContent() { }
    _defaultValueSet = false;
    focus() {
        this.nativeView.becomeFirstResponder();
    }
    blur() {
        this.nativeView.resignFirstResponder();
    }
    clear() {
        this.nativeView.stringValue = '';
    }
};
__decorate([
    native({
        setNative: (view, key, value) => {
            if (view.nativeView) {
                view.nativeView.stringValue = value;
            }
            view._defaultValueSet = true;
        },
        shouldLayout: true,
    }),
    __metadata("design:type", String)
], TextField.prototype, "value", void 0);
__decorate([
    native({
        setNative: (view, key, value) => {
            if (view._defaultValueSet)
                return;
            if (view.nativeView && !view.nativeView.stringValue) {
                view.nativeView.stringValue = value;
            }
        },
        shouldLayout: true,
    }),
    __metadata("design:type", String)
], TextField.prototype, "defaultValue", void 0);
__decorate([
    native({
        setNative: (view, key, value) => {
            if (view.nativeView) {
                view.nativeView.placeholderString = value;
            }
        },
        shouldLayout: true,
    }),
    __metadata("design:type", Object)
], TextField.prototype, "placeholder", void 0);
__decorate([
    native({
        setNative: (view, key, value) => {
            if (view.nativeView) {
                view.nativeView.isEditable = value;
            }
        },
    }),
    __metadata("design:type", Boolean)
], TextField.prototype, "editable", void 0);
__decorate([
    native({
        setNative: (view, key, value) => {
            if (view.nativeView) {
                view.nativeView.usesSingleLineMode = value;
            }
        },
        shouldLayout: true,
    }),
    __metadata("design:type", Boolean)
], TextField.prototype, "multiline", void 0);
TextField = __decorate([
    view({
        name: 'HTMLTextFieldElement',
        tagName: 'text-field',
    })
], TextField);
export { TextField };
//# sourceMappingURL=text-field.js.map