var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var NativeToolbarGroupTarget_1;
import '@nativescript/macos-node-api';
import { view } from '../decorators/view.js';
import { Event } from '../../dom/dom-utils.js';
import { ToolbarItem } from './toolbar-item.js';
import { native } from '../decorators/native.js';
export class ToolbarGroupSelectedEvent extends Event {
    selectedIndex;
    constructor(selectedIndex, eventDict) {
        super('selected', eventDict);
        this.selectedIndex = selectedIndex;
    }
}
let NativeToolbarGroupTarget = class NativeToolbarGroupTarget extends NSObject {
    static { NativeToolbarGroupTarget_1 = this; }
    static ObjCExposedMethods = {
        selected: { returns: interop.types.void, params: [interop.types.id] },
    };
    _owner;
    static initWithOwner(owner) {
        const item = NativeToolbarGroupTarget_1.new();
        item._owner = owner;
        return item;
    }
    selected(sender) {
        const owner = this._owner?.deref();
        if (owner) {
            owner.dispatchEvent(new ToolbarGroupSelectedEvent(sender.selectedIndex));
        }
    }
};
NativeToolbarGroupTarget = NativeToolbarGroupTarget_1 = __decorate([
    NativeClass
], NativeToolbarGroupTarget);
let ToolbarGroup = class ToolbarGroup extends ToolbarItem {
    nativeView = undefined;
    target;
    items = [];
    initNativeView() {
        this.target = NativeToolbarGroupTarget.initWithOwner(new WeakRef(this));
        this.nativeView = NSToolbarItemGroup.alloc().initWithItemIdentifier(crypto.randomUUID());
        return this.nativeView;
    }
    disposeNativeView() {
        this.target = undefined;
        this.items = [];
        this.nativeView = undefined;
    }
    addNativeChild(child) {
        if (child.nodeName === 'TOOLBAR-ITEM') {
            this.items.push(child.nativeView);
            if (this.nativeView) {
                this.nativeView.subitems = this.items;
            }
        }
        else {
            throw new Error(`Invalid child type added to toolbar-item: ${child.nodeName}`);
        }
    }
    removeNativeChild(child) {
        if (child.nodeName === 'TOOLBAR-ITEM') {
            const index = this.items.indexOf(child.nativeView);
            if (index !== -1) {
                this.items.splice(index, 1);
                if (this.nativeView) {
                    this.nativeView.subitems = this.items;
                }
            }
        }
        else {
            throw new Error(`Invalid child type removed from toolbar-item: ${child.nodeName}`);
        }
    }
};
__decorate([
    native({
        setNative: (view, _key, value) => {
            if (view.nativeView) {
                view.nativeView.selectedIndex = value;
            }
        },
    }),
    __metadata("design:type", Number)
], ToolbarGroup.prototype, "selectedIndex", void 0);
__decorate([
    native({
        setNative: (view, _key, value) => {
            if (view.nativeView) {
                switch (value) {
                    case 'selectOne':
                        view.nativeView.selectionMode = NSToolbarItemGroupSelectionMode.SelectOne;
                        break;
                    case 'selectAny':
                        view.nativeView.selectionMode = NSToolbarItemGroupSelectionMode.SelectAny;
                        break;
                    case 'momentary':
                        view.nativeView.selectionMode = NSToolbarItemGroupSelectionMode.Momentary;
                        break;
                    default:
                        throw new Error(`Invalid selection mode: ${value}`);
                }
            }
        },
    }),
    __metadata("design:type", String)
], ToolbarGroup.prototype, "selectionMode", void 0);
__decorate([
    native({
        setNative: (view, _key, value) => {
            if (view.nativeView) {
                view.nativeView = NSToolbarItemGroup.groupWithItemIdentifierTitlesSelectionModeLabelsTargetAction(crypto.randomUUID(), value, view.nativeView.selectionMode, value, view.target, 'selected');
                view.nativeView.controlRepresentation = NSToolbarItemGroupControlRepresentation.Automatic;
            }
        },
    }),
    __metadata("design:type", Array)
], ToolbarGroup.prototype, "titles", void 0);
ToolbarGroup = __decorate([
    view({
        name: 'HTMLToolbarGroupElement',
        tagName: 'toolbar-group',
    })
], ToolbarGroup);
export { ToolbarGroup };
//# sourceMappingURL=toolbar-group.js.map