var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var ToolbarDelegate_1;
import '@nativescript/macos-node-api';
import { view } from '../decorators/view.js';
import { ViewBase } from '../view/view-base.js';
let ToolbarDelegate = class ToolbarDelegate extends NSObject {
    static { ToolbarDelegate_1 = this; }
    static ObjCProtocols = [NSToolbarDelegate];
    items = [];
    _owner;
    static initWithOwner(owner) {
        const delegate = ToolbarDelegate_1.new();
        delegate._owner = owner;
        return delegate;
    }
    validateToolbarItem(_item) {
        return true;
    }
    toolbarItemForItemIdentifierWillBeInsertedIntoToolbar(_toolbar, itemIdentifier, _flag) {
        return this.items.find((item) => item.itemIdentifier === itemIdentifier);
    }
    toolbarDefaultItemIdentifiers(_toolbar) {
        return this.items.map((item) => item.itemIdentifier);
    }
    toolbarAllowedItemIdentifiers(toolbar) {
        return this.toolbarDefaultItemIdentifiers(toolbar);
    }
};
ToolbarDelegate = ToolbarDelegate_1 = __decorate([
    NativeClass
], ToolbarDelegate);
let Toolbar = class Toolbar extends ViewBase {
    _isEnabled = false;
    nativeView = undefined;
    toolbarDelegate;
    initNativeView() {
        this.nativeView = NSToolbar.new();
        this.toolbarDelegate = ToolbarDelegate.initWithOwner(new WeakRef(this));
        this.nativeView.delegate = this.toolbarDelegate;
        this.nativeView.displayMode = NSToolbarDisplayMode.IconOnly;
        return this.nativeView;
    }
    disposeNativeView() {
        this.nativeView = undefined;
    }
    reloadToolbar() {
        this.nativeView?.validateVisibleItems();
    }
    addNativeChild(child) {
        if (child.nodeName === 'TOOLBAR-ITEM' || child.nodeName === 'TOOLBAR-TOGGLE-SIDEBAR' || child.nodeName === 'TOOLBAR-SIDEBAR-TRACKING-SEPARATOR' || child.nodeName === 'TOOLBAR-FLEXIBLE-SPACE' || child.nodeName === 'TOOLBAR-GROUP') {
            this.toolbarDelegate.items.push(child.nativeView);
            this.reloadToolbar();
        }
        else {
            throw new Error(`Invalid child type added to toolbar: ${child.nodeName}`);
        }
    }
    removeNativeChild(child) {
        if (child.nodeName === 'TOOLBAR-ITEM' || child.nodeName === 'TOOLBAR-TOGGLE-SIDEBAR' || child.nodeName === 'TOOLBAR-SIDEBAR-TRACKING-SEPARATOR' || child.nodeName === 'TOOLBAR-FLEXIBLE-SPACE' || child.nodeName === 'TOOLBAR-GROUP') {
            const index = this.toolbarDelegate.items.indexOf(child.nativeView);
            if (index !== -1) {
                this.toolbarDelegate.items.splice(index, 1);
                this.reloadToolbar();
            }
        }
        else {
            throw new Error(`Invalid child type removed from toolbar: ${child.nodeName}`);
        }
    }
};
Toolbar = __decorate([
    view({
        name: 'HTMLToolbarElement',
        tagName: 'toolbar',
    })
], Toolbar);
export { Toolbar };
//# sourceMappingURL=toolbar.js.map