import '@nativescript/macos-node-api';
import { Event } from '../../dom/dom-utils.js';
import type { Window } from './window.js';
import type { ViewBase } from '../view/view-base.js';
export declare class WindowResizeEvent extends Event {
    width: number;
    height: number;
    constructor();
    initWindowEvent(type: string, bubbles?: boolean, cancelable?: boolean, width?: number, height?: number): void;
}
export declare class MainWindowController extends NSWindowController implements NSToolbarDelegate {
    static ObjCProtocols: (typeof NSToolbarDelegate)[];
    _owner: WeakRef<ViewBase>;
    static initWithOwner(owner: WeakRef<ViewBase>): MainWindowController;
}
export declare class NativeWindow extends NSWindow implements NSWindowDelegate {
    static ObjCProtocols: (typeof NSWindowDelegate)[];
    owner?: WeakRef<Window>;
    windowDidResize(_notification: NSNotification): void;
    windowDidBecomeKey(_notification: NSNotification): void;
    windowDidBecomeMain(_notification: NSNotification): void;
    windowWillClose(_notification: NSNotification): void;
}
