import { YogaNodeLayout } from '../../layout/index.js';
import { ViewBase } from '../view/view-base.js';
import { MainWindowController, NativeWindow } from './native-window.js';
export declare class Window extends ViewBase {
    isRoot: boolean;
    shouldAttachToParentNativeView: boolean;
    nativeView?: NativeWindow;
    mainWindowCtrl: MainWindowController;
    initNativeView(): NativeWindow;
    disposeNativeView(): void;
    applyLayout(parentLayout?: YogaNodeLayout): void;
    open(): void;
    _isModal?: boolean;
    openAsModal(relativeToWindow?: boolean): void;
    closeModalWindow(): void;
    close(): void;
    insertBefore<T extends Node>(node: T, child: Node | null): T;
    addNativeChild(child: ViewBase): void;
    removeNativeChild(child: ViewBase): void;
    transparentTitleBar: boolean;
    title: string;
    subtitle: string;
    onSetBackgroundColor(_key: string, value: any): void;
    styleMask: typeof NSWindowStyleMask;
    releasedWhenClosed: boolean;
}
